/// <reference types="hoist-non-react-statics" />
import React from "react";
import Animated from "react-native-reanimated";
import { SpringConfig } from "@tleef/react-native-reanimated-utils/lib";
import { SceneType } from "./Scene";
import { InjectedStageProps } from "./withStage";
declare type TransitionArgs = {
    from: string;
    to: string;
    springConfig?: Partial<SpringConfig>;
};
declare type State = {
    from?: string;
    fromScene?: SceneType;
    to?: string;
    toScene?: SceneType;
};
declare type StartHandler = () => void;
declare type EndHandler = (cancelled: boolean) => void;
declare class SceneTransitioner extends React.Component<InjectedStageProps, State> {
    private _driver;
    private _inOut;
    private _prevInOut;
    private _drive;
    private _enterStartListeners;
    private _enterEndListeners;
    private _leaveStartListeners;
    private _leaveEndListeners;
    constructor(props: InjectedStageProps);
    render(): JSX.Element | null;
    transition: ({ from, to, springConfig }: TransitionArgs) => TransitionReceipt;
    reset: () => void;
    private _resetAnimation;
    private _resetState;
    private _onEnterStart;
    private _onEnterEnd;
    private _onLeaveStart;
    private _onLeaveEnd;
    private _handleAddScene;
}
declare class TransitionReceipt {
    private readonly _inOut;
    private readonly _enterStartListeners;
    private readonly _enterEndListeners;
    private readonly _leaveStartListeners;
    private readonly _leaveEndListeners;
    constructor(inOut: Animated.Value<-1 | 0 | 1>, enterStartListeners: Array<StartHandler>, enterEndListeners: Array<EndHandler>, leaveStartListeners: Array<StartHandler>, leaveEndListeners: Array<EndHandler>);
    cancel: () => void;
    onEnterStart: (handler: StartHandler) => void;
    onEnterEnd: (handler: EndHandler) => void;
    onLeaveStart: (handler: StartHandler) => void;
    onLeaveEnd: (handler: EndHandler) => void;
}
declare const _default: {
    (props: any): JSX.Element;
    displayName: string;
    WrappedComponent: typeof SceneTransitioner;
} & import("hoist-non-react-statics").NonReactStatics<typeof SceneTransitioner, {}>;
export default _default;
